<?php

class PkolValidationModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function postProcess()
    {

        $cart = $this->context->cart;
        $this->langID = (int)Configuration::get('PS_LANG_DEFAULT');
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'pkol') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }

        $this->context->smarty->assign([
            'params' => $_REQUEST,
        ]);
        $data = [];
        $products = Context::getContext()->cart->getProducts();
        $cart = Context::getContext()->cart;


        $product_ids = [];

        $pko = new Pkol();

        $n = 1;
        $type = 'ORDER';
        $form = '<form id="leasing" action="' . $pko->lease_url . '"  method="POST">';
        $form .= '<input type="hidden" name="shopId" value="' . $pko->shopID . '" />';
        $form .= '<input type="hidden" name="orderId" value="' . $cart->id . '" />';
        $form .= '<input type="hidden" name="returnLink" value="' . Tools::getHttpHost(true) . __PS_BASE_URI__ . '" />';
        $form .= '<input type="hidden" name="uniqueItemQuantity" value="' . count($products) . '" />';
        $total = 0;
        $total_wt = 0;
        foreach ($products as $product) {
            $pid = $product['id_product'];

            $quantity = $product['cart_quantity'];
            $p = new Product($pid, false, $this->langID);
            $att_id = null;
            if ($product['id_product_attribute'] > 0) {
                $att_id = $product['id_product_attribute'];
            }
            if ($att_id) {
                $att = $att_id;
                $product_data = $pko->getProduct($pid, $att_id);
                $p->name = $product_data['product_name'];
                $price_without_tax = $product_data['price_without_tax'];
                $price_with_tax = $product_data['price_with_tax'];

            } else {
                $att = null;
                $price_without_tax = str_replace(',', '', number_format($p->getPriceStatic($pid, false, $att, 2), 2));
                $price_with_tax = str_replace(',', '', number_format($p->getPriceStatic($pid, true, $att, 2), 2));
            }
            $cat_id = $p->id_category_default;
            $price = $product['specific_prices'];
            $p_quant = $quantity;

            $form .= '<input type="hidden" name="productName' . $n . '" value="' . $p->name . '" />';

            $form .= '<input type="hidden" name="productPrice' . $n . '" value="' . $price_with_tax . '" />';

            $form .= '<input type="hidden" name="productNetPrice' . $n . '" value="' . $price_without_tax . '" />';
            $form .= '<input type="hidden" name="productQuantity' . $n . '" value="' . $p_quant . '" />';
            $form .= '<input type="hidden" name="productCategory' . $n . '" value="' . $cat_id . '" />';
            $form .= '<input type="hidden" name="productVatRate' . $n . '" value="' . $pko->getRate($p->getTaxesRate()) . '" />';
            $total = $total + $price_without_tax * $p_quant;
            $total_wt = $total_wt + $price_with_tax * $p_quant;
            $n++;
        }

        $form .= '<input type="hidden" name="totalValue" value="' . number_format($cart->getOrderTotal() - $cart->getPackageShippingCost(), 2, '.', '') . '" />';
        $form .= '<input type="hidden" name="totalNetValue" value="' . number_format((float)$total, 2, '.', '') . '" />';


        $form .= '<input type="hidden" name="source" value="' . $type . '" />';
        $form .= '</form>';

        $customer = new Customer($cart->id_customer);
        if (!Validate::isLoadedObject($customer))
            Tools::redirect('index.php?controller=order&step=1');

        $currency = $this->context->currency;
        $total = (float)$cart->getOrderTotal(true, Cart::BOTH);
        $mailVars = [];


        $form .= '<script>document.getElementById("leasing").submit();</script>';
        $this->module->validateOrder($cart->id, Configuration::get('PS_OS_BANKWIRE'), $total, $this->module->displayName, NULL, $mailVars, (int)$currency->id, false, $customer->secure_key);
        echo $form;
        exit();
    }
}
